var cropper,
    sale_cropper,
    FIRSTFONT,
    image_index=0,
    SCREEN_WIDTH,
    IMGE_DEFAULT_HEIGHT = 90.5,
    IMAGE_PLACEHOLDER_WIDTH,
    IMAGE_PLACEHOLDER_HEIGHT,
    SALE_IMAGE_PLACEHOLDER_WIDTH, //特卖图片宽
    SALE_IMAGE_PLACEHOLDER_HEIGHT,//特卖图片高
    PLACEHOLDER_SLOPE = 174 / 294, // 标准框比例
    CONTENT_PADDING = 24, // 两侧空白区域
    blank = 10,
    //顶部大图比例
    TOP_BANNER_SLOPE = 530/720,
    imgQuene = [],
    srcs = [],
    display = 0, //列表展示标志
    topFlag = 0,
    delatHeight = 0,
    loadMode,
    offlineMode,
    isWifiNet,
    claimer = false, //是否有免责声明
    VIDEO_SLOP = 9/16,//视频宽高比
    video_p = '<!-- IFENG_DOC_VIDEO -->',
    slide_p = '<!-- IFENG_DOC_SLIDE -->',
    survey_p= '<!-- IFENG_DOC_SURVEY -->',
    center_ad_p='<!-- IFENG_DOC_ADVERT -->',
    audio_p = '<!-- IFENG_DOC_AUDIO -->',
    class_iwords = 'iwords',
    FONTS={
        'small'    : 0,
        'mid'      : 1,
        'big'      : 2,
        'bigger'   : 3,
    },
    nophoto_arrays=[	//无图模式或离散图片加载状态
        "nophoto_load.png",    //点击加载
        "nophoto_loading.png", //加载中
        "nophoto_load.png",    //加载失败
    ],
    hasBodyAd = false,            //是否有正文（中韩频道）广告
    BODY_AD_WIDTH = 0,            //正文广告宽
    BODY_AD_HEIGHT = 0,           //正文广告高
    BODY_AD_CENTER_RADIO = 480 / 400;    //正文中间通发广告宽高比
    BODY_AD_RADIO = 668 / 202;    //正文广告宽高比

// 监听 deviceready 事件 执行 init 方法初始化逻辑
window.addEventListener('deviceready', init, false);

// 初始化所有业务逻辑
function init(e) {
    console.log("init");
    loadMode = ifeng.is2g3gloadMode();
    offlineMode = ifeng.isOfflineMode();
    isWifiNet = ifeng.isWifiNet();
    if(offlineMode) {
        nophoto_arrays = [
            "offline_load.png",
            "offline_loading.png",
            "offline_load.png"
        ];
    }

    SCREEN_WIDTH = e.clientWidth;

    //若WebView未显示则e.clientWidth无法获取窗口宽度，通过native方法获取设备宽度的DP值
    if(isNaN(SCREEN_WIDTH)){
        SCREEN_WIDTH = ifeng.getScreenWidth();
    }
    console.log("SCREEN_WIDTH:" + SCREEN_WIDTH);

    IMAGE_PLACEHOLDER_WIDTH = SCREEN_WIDTH - 26;
    IMAGE_PLACEHOLDER_HEIGHT = Math.round(IMAGE_PLACEHOLDER_WIDTH
        * PLACEHOLDER_SLOPE);
    SALE_IMAGE_PLACEHOLDER_WIDTH = IMAGE_PLACEHOLDER_WIDTH - 24;
    SALE_IMAGE_PLACEHOLDER_HEIGHT = Math.round(SALE_IMAGE_PLACEHOLDER_WIDTH
        * PLACEHOLDER_SLOPE);
    cropper = new ImageCropper(new StandPlaceholderCropStrategy(
        IMAGE_PLACEHOLDER_WIDTH));
    sale_cropper = new ImageCropper(new StandPlaceholderCropStrategy(
        SALE_IMAGE_PLACEHOLDER_WIDTH));

    //正文（中韩频道/本地）广告
    var isChannelHasBodyAd = ifeng.isChannelHasBodyAd();
    var adData;
    if (isChannelHasBodyAd) {
        var bodyAdData = datas.getRandomBodyAdvertJson();
        if (bodyAdData != null && bodyAdData != "" && bodyAdData != 'undefined') {
           hasBodyAd = true;
           adData = JSON.parse(bodyAdData);
        }
    }
    if (hasBodyAd) {
        BODY_AD_WIDTH = SCREEN_WIDTH - 24;
        BODY_AD_HEIGHT = Math.round(BODY_AD_WIDTH / BODY_AD_RADIO);
        var bodyAdWrapper = document.getElementById('body_ad_wrapper');
        bodyAdWrapper.style.width = BODY_AD_WIDTH + 2 + 'px';
        bodyAdWrapper.style.display = 'block';
        bodyAdWrapper.onclick = function() {
            ifeng.bodyAdClick(adData.url, adData.title);
        }

        var bodyAdImage = document.getElementById('body_ad_img');
        var loadMessage = getLoadingImage();
        bodyAdImage.innerHTML = loadMessage;
        bodyAdImage.style.width = BODY_AD_WIDTH + 'px';
        bodyAdImage.style.height = BODY_AD_HEIGHT + 'px';

        var bodyAdTitle = document.getElementById('body_ad_title');
        bodyAdTitle.innerHTML = adData.title;
    }
    // 写入标题
    initNewsTitle();

    initSource(datas);

    // 设置简介
    initSummary(datas.getSummary());

    // 获取自媒体信息底部的Y值
    setAuthorTitleBottomY();
    // 设置大小字体
    setFontSize(datas.getFontSize(),datas.getDocTitleFontSize(),datas.getDocContentFontSize(),datas.getSummaryFontSize());
    // 处理图片后 填充正文内容
    preprocessImage(formatText(datas.getText()),
        document.getElementById('content'),datas.getShortDocRelateTitleFontSize());

    setPicIntroFontSize(datas.getFontSize(),datas.getPicIntroFontSize());

    //初始化音频
    initAudio();
    initCardAd();
    //增加作者和责任编辑
    initEditorCode(datas.getAuthor(),datas.getEditorcode());
    //初始化免责声明
    initClaimer(datas.getDisclaimer(), datas.getOriginalLink());

   if (hasBodyAd) {
       ifeng.getBodyAdImage(adData.thumbnail);
   }
   fixErrorSpace();

   dealWithSurveyContentView();

   dealwithTextAtag(document.getElementById('content'));
}

function prependChild(parent,newChild){
    if(parent.firstChild){
        parent.insertBefore(newChild,parent.firstChild);
    } else {
        parent.appendChild(newChild);
    }
    return parent;
}

//处理正文中图片
function processImage(cropper,default_height,content,container,imgInfo) {
    var loadMessage = '';
    if(loadMode!=1 && !offlineMode) {
        loadMessage = getLoadingImage();
    }
    var fragment = document.createElement('div');

    fragment.innerHTML = content;
    var imgEls = Array.prototype.slice.call(fragment.getElementsByTagName('ifengimg')), isFormat = true;
    //如果传过来的json数据格式错误，使用默认底图
    if (!imgInfo || Object.prototype.toString.call(imgInfo) !== '[object String]') {
        isFormat = false;
    }
    try {
        try{
            var imgObj = JSON.parse(imgInfo);
        } catch (e) {
            imgObj = undefined;
        }
        for ( var i = 0; i < imgEls.length; i++) {
            var img = imgEls[i], parent = img.parentNode, placeholder = document.createElement('div');

            //处理图片外层的 <a> 标签
            if (parent.nodeName == 'A') {
                var ifenghref = parent.getAttribute("ifengapp-data");
                var tempHref = parent.getAttribute("href");
                if (ifenghref != null) {
                    placeholder.setAttribute("jumpUrl", parent.getAttribute("ifengapp-data"));
                } else if (tempHref != null) {
                    placeholder.setAttribute("jumpUrl", parent.getAttribute("href"));
                }
                parent.parentNode.replaceChild(img, parent);
                parent = img.parentNode;
            }

            if (!img.getAttribute('src')) {
                continue;
            }
            var imgUrl = img.getAttribute('src');
            var isSale = false;
            try {
                isSale = (img.className == "clientSale_img") || (img.parentNode.parentNode.className == "product_img");
            }catch(e){}
            var image_height = '';
            placeholder.id = 'imgPlaceholder';
            placeholder.className = 'placeholder ' + datas.getFontSize();
            placeholder.setAttribute('src', img.getAttribute('src'));
            placeholder.setAttribute('index', i+image_index);
            placeholder.setAttribute('sale_flag', (isSale?"1":"0"));
            placeholder.setAttribute('loadState', 'loading');
            placeholder.setAttribute('placeholder_tag','tag');
            placeholder.setAttribute('background','#ff00ff');
            srcs.push(img.getAttribute('src'));

            var setwidth = false;
            var image_width;
            //初始化默认底图的高（根据屏幕的宽和服务器传过来的高）
            if (isFormat&&imgObj&&imgObj[img.getAttribute('src')]) {
                var width = imgObj[img.getAttribute('src')].width, height = imgObj[img
                    .getAttribute('src')].height;
                if (width && height) {
                    if(isSale) {
                        result = sale_cropper.getResult(width, height);
                    } else {
                        result = cropper.getResult(width, height);
                    }
                    if(result.height == 0) {
                        image_height =  (isSale?SALE_IMAGE_PLACEHOLDER_HEIGHT:default_height)+ 'px';
                    } else {
                        image_height =  result.height+ 'px';
                    }
                } else {
                    // 如果没有获取到高，就用默认高
                    image_height =  (isSale?SALE_IMAGE_PLACEHOLDER_HEIGHT:default_height)+ 'px';
                }
            } else {
                var reg= new RegExp("_w(\\d+)_h(\\d+)","g");
                var result = null,next_result;

                while((next_result=reg.exec(imgUrl))!=null) {
                    result = next_result;
                };
                var w=0, h=0;
                if(result&&result.length==3) {
                    w = result[1];
                    h = result[2];
                }
                if(w < SCREEN_WIDTH*0.7 && h){
                    setwidth = true;
                    image_width = w+'px';
                    image_height = h+ 'px';
                }else{
                    if(w && h) {
                          if(isSale) {
                                result = sale_cropper.getResult(w, h);
                          } else {
                                result = cropper.getResult(w, h);
                          }
                          if(result.height == 0) {
                                image_height = (isSale?SALE_IMAGE_PLACEHOLDER_HEIGHT:default_height)+ 'px';
                          } else {
                                image_height = result.height+'px';
                          }
                    } else {
                          // 如果没有获取到高，就用默认高
                          image_height = (isSale?SALE_IMAGE_PLACEHOLDER_HEIGHT:default_height)+ 'px';
                    }
                }
            }
            if(setwidth){
                placeholder.style.width = image_width;
            }
            if(offlineMode || loadMode == 1) {
                placeholder.style.height = placeholder.style.minHeight = IMGE_DEFAULT_HEIGHT+'px';
                placeholder.setAttribute('image_height',image_height);
            } else {
                placeholder.style.height = placeholder.style.minHeight = image_height;
            }

            placeholder.innerHTML= loadMessage;
            if(isSale) {
                try {
                    placeholder.style.marginBottom = "0px";
                    parent.setAttribute("href",parent.getAttribute("href")+"sale_flag");

                    var link_wrapper = parent.parentNode.parentNode.getElementsByClassName("product_link");

                    if(link_wrapper && link_wrapper.length>0 &&	link_wrapper[0].childNodes && link_wrapper[0].childNodes.length>0) {
                        link_wrapper[0].childNodes[0].setAttribute("href",link_wrapper[0].childNodes[0].getAttribute("href")+"sale_flag");
                    }

                    parent.replaceChild(placeholder, img);
                }catch(e) {
                    sendWebLog('sale img error', datas.getText());
                    try{
                        parent.parentNode.parentNode.style.display="none";
                    }catch(e) {
                    }
                }
            } else {
                parent.parentNode.replaceChild(placeholder, parent);
            }

        }
        image_index+=imgEls.length;
    }catch (e){
        sendWebLog('text img error', datas.getText());
    }
    return fragment.innerHTML;
}

//初始化自媒体免责声明
function initClaimer(disclaimer, originalLink) {
    var success = false;
    if (disclaimer
        && Object.prototype.toString.call(disclaimer) === '[object String]') {
        document.getElementById("disclaimer").innerText = disclaimer;
        success = true;
    }
    if(originalLink
        && Object.prototype.toString.call(originalLink) === '[object String]') {
        success = true;
        var originBtn  = document.getElementById("originBtn");
        originBtn.innerText = "阅读原文";
        originBtn.onclick = function() {
            ifeng.jump('webfull', originalLink,"","disclaimer");
        };
    } else {
        document.getElementById("originBtn").style.display = "none";
        if(success) {document.getElementById("disclaimer").marginBottom = "0px";}
    }
    if(success) {
        if(topFlag == 0) {
            document.getElementById('ifeng-article').style.paddingBottom = "0px";
        }
        document.getElementById("disclamer_wrapper").style.display = "block";
        claimer = true;
    }
}

/**
  *  客户端正文内的热词标签点击跳转.
  *
  */
function addIWordsClickLister(container){

     var classArrs = container.getElementsByClassName(class_iwords);
     if(classArrs != null && classArrs.length > 0){

         for(var i = 0; i < classArrs.length; i ++){
             if(classArrs[i] != null && classArrs[i] != undefined){
                 classArrs[i].onclick = function(){
                      ifeng.goToSearch(this.innerText);
                 };
             }
         }
     }
}

// 设置正文字体
function setFontSize(fs,titleFontSize,contentFontSize,summaryFontSize) {
    var tdom = document.getElementById('title');
    var declareDom = document.getElementById('detail_declare');
    var cdom = document.getElementById('content');
    var summaryParentDom = document.getElementById('summary_parent');
    var summaryDom = document.getElementById('summary');
    var unfoldDom = document.getElementById('unfold_bottom-space');
    if(fs){
        if(FIRSTFONT){
            var offset = FONTS[fs] - FONTS[FIRSTFONT];
            var spans = document.getElementsByName('content_span');
            for(var i=0; i<spans.length; i++){
                var spanClass = spans[i].getAttribute('class');
                for(var font in FONTS){
                    if(FONTS[font] == FONTS[spanClass]+offset){
                        spans[i].setAttribute('class', font);
                    }
                }
            }
        }
        FIRSTFONT = fs;
        // 重设class
        cdom.className = 'content ' + fs;
        tdom.className = 'title '+ fs;
        declareDom.className = 'detail_declare detail_declare_color '+ fs;
        summaryParentDom.className = 'summary_parent '+ fs;
        summaryDom.className = 'summary '+ fs;
        unfoldDom.className = 'unfold_bottom-space '+ fs;

        // 重设字体大小
        cdom.style.fontSize  = contentFontSize +'px'
        tdom.style.fontSize  = titleFontSize +'px'
        summaryDom.style.fontSize  = summaryFontSize +'px'
//        console.log(cdom.innerHTML);
    }
    //字体大小改变时，重新定位音频控件的位置
    initAudio();
    initCardAd();
}

// 设置图注字体
function setPicIntroFontSize(fs,picIntroFontSize) {
    var picIntroDom = document.getElementsByClassName("picIntro");
    if(fs){
        for (var i =0;i < picIntroDom.length;i ++) {
            picIntroDom[i].className = 'picIntro ' + fs;
        }

    }
    //字体大小改变时，重新定位音频控件的位置
    initAudio();
    initCardAd();
}

function getRecommentItem(items) {
    var i, itemLength = items.length,content = '';
    for(i=0;i<itemLength;i++) {
        if(items[i].thumbnail) {
            content+= '<div type="'+items[i].type+'" linkUrl="'+items[i].url+'" class="recommend-container"><div class="recommend-left"><img src="'+(loadMode==1?"list_no_img.JPG":"list_default.jpg")+'" recommendSrc="'+
                items[i].thumbnail+'"/></div><div class="recommend-right"><span>'+items[i].title+'</span></div></div>';
        } else {
            content+= '<div type="'+items[i].type+'" linkUrl="'+items[i].url+'" class="recommend-container"><div class="recommend-right" style="padding-left:0px;min-height:64px;height:64px;overflow:hidden;"><span>'+items[i].title+'</span></div></div>';
        }
    }
    return content;
}

//下载图片
function loadListImages(docs,srcName) {
    var imgs = docs.getElementsByTagName('img');
    for(var i=0;i<imgs.length;i++) {
        var imageDom = imgs[i],imageSrc = imageDom.getAttribute(srcName);
        if(imageSrc) {
            Ground.loadImageDirectly(imageSrc, null,
                loadImageSuccessInterceptor(imageDom, i),
                loadImageFailInterceptor(imageDom, imageDom.getAttribute(srcName)), 'false');
        }
    }
}

//初始化相关阅读的图集
function initReadSlideData(item) {
    var length = 0;
    var content = '';
    if(!item.thumbnail){
        length = item.style.images.length;
        content = '<div type="' + item.type + '" linkUrl="' + item.link.url + '" class="recommend-container"><div class="read-content-side-title"><span>' + item.title + '</span></div><br/>';
        var imageWidth = ((IMAGE_PLACEHOLDER_WIDTH-30)/3);
        var imageHeight = Math.round(imageWidth*55/81);
        for(var index=0,length = 2;index<=length;index++) {
            content += '<div class="read-item"><img src="'+(loadMode==1?"album_no_img.JPG":"album_default.JPG")+'" width="'+imageWidth+'" height="'+
                imageHeight+'" readImgSrc="'+item.style.images[index]+'"/></div>';

        }
        content += '</div>';
    }else{
        content+= '<div type="' + item.type + '" linkUrl="' + item.link.url + '" class="recommend-container"><div class="recommend-left"><img src="' + (loadMode == 1 ? "list_no_img.JPG" : "list_default.jpg") + '" readImgSrc="' +
            item.thumbnail + '"/></div><div class="recommend-right"><span>' + item.title + '</span><br/><img  src="channel_list_new_photo.png" width="11" height="10" style="padding-left:1.5px"/></div></div>';
    }
    return content;
}

//根据指定字号计算字符所占宽度
function textSize(text) {
    var span = document.createElement("span");
    var result = {};
    result.width = span.offsetWidth;
    result.height = span.offsetWidth;
    span.style.visibility = "hidden";
    span.className = 'adv';
    document.body.appendChild(span);
    if (typeof span.textContent != "undefined")
        span.textContent = text;
    else span.innerText = text;
    result.width = span.offsetWidth - result.width;
    result.height = span.offsetHeight - result.height;
    span.parentNode.removeChild(span);
    return result;
}

function offsetTop( elements ){
    var top = elements.offsetTop;
    var parent = elements.offsetParent;
    while( parent != null ){
        top += parent.offsetTop;
        parent = parent.offsetParent;
    };
    return top;
};

//作者和责任编辑
function initEditorCode(author,editorCode) {

    var editor = document.getElementById('editor');
    if((!author||author.length<1)&&(!editorCode || editorCode.length < 1)) {
        editor.style.display = 'none';
        document.getElementById('editor_div').style.display = 'none';
        return false;
    }
    var container = document.getElementById('ifeng-article');
    container.style.paddingBottom = '0px';
    var authorText = '';
    if(author&&author.length>1){
        authorText = '作者: '+author;
    }

    var editorCodeText = '';
    if(editorCode || editorCode.length > 1){
        editorCodeText = '责任编辑: '+editorCode;
    }
    editor.style.display = 'inline';
    if(authorText && authorText.length>1){
        editor.innerHTML =authorText+'&emsp;'+editorCodeText;
    }else{
        editor.innerHTML =editorCodeText;
    }
    topFlag = 1;
    document.getElementById('insert-news').style.paddingBottom = "0px";
}

function subSuccess() {
    return function(subState){
        var subButton = document.getElementById('subscription-button');
        if(subState){
            subButton.setAttribute("src", "delete_sub_detail.png");
        }else{
            subButton.setAttribute("src", "add_sub_detail.png");
        }
    };
}

//得到图集的宽和高 如果有宽和高的话，需要重新设置min-height为返回的高
function getHeightRule() {
    var extraRule = '';
    if(arguments[0].thumbnailSize) {
        var width = arguments[0].thumbnailSize.width, height = arguments[0].thumbnailSize.height;
        if (width && height) {
            var minheight = "min-height:"+IMAGE_PLACEHOLDER_HEIGHT+"px";
            extraRule = minheight;
        }
    }
    return extraRule;
}

function getCenterAdHeightRule(item){
    var extraRule = '';
        if(item.imageWidth && item.imageHeight) {
            var width = item.imageWidth, height = item.imageHeight;
            if (width && height) {
                var minheight = 'min-height:'+cropper.getResult(width, height).height+'px';
                extraRule = 'style="'+minheight+'"';
            }
        }
        return extraRule;
}

function getVideoRule() {
    return 'style="min-height:'+IMAGE_PLACEHOLDER_WIDTH*VIDEO_SLOP+'px"';
}

function getContentPosition(content,str) {
    var index=0,list = [];
    while((index=content.indexOf(str,index))!=-1) {
        list.push(index++);
    }
    return list;
}

function insertStr(source,str,position) {
    var str_sta = source.substring(0, position);
    var str_end = source.substring(position);
    return str_sta+str+str_end;
}

// 处理 图集,视频占位符
function handle_img_position(content,flag_p,item_length,getItem) {
    var list = getContentPosition(content, flag_p),
        length = list.length,
        flag_p_length = flag_p.length;
    if(length>0) {
        var i,j,temp_sum,min_length = Math.min(length, item_length);
        content = content.replace(new RegExp(flag_p,"gm"),"");
        for(i=0;i<length;i++) {
            list[i]-=flag_p_length*i;
        }
        for(j=0,temp_sum=0;j<min_length;j++) {
            var item_str = getItem(j);
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = insertStr(content, item_str, temp_sum+list[j]);
            temp_sum+=item_str.length;
        }
        if(length<item_length) {
            for(i=item_length-1; i>=j; i--) {
                var item_str = getItem(i);
                if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                    continue;
                }
                content = item_str + content;
            }
        }
    } else {
        for(var i = item_length-1; i > -1; i--) {
            var item_str = getItem(i);
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = item_str + content;
        }
    }
    return content;
}

// 处理调查占位符
function handle_survey_position(content,flag_p,item_length,getItem) {
    var list = getContentPosition(content, flag_p),
        length = list.length,
        flag_p_length = flag_p.length;
    if(length>0) {
        var i,j,temp_sum,min_length = Math.min(length, item_length);
        content = content.replace(new RegExp(flag_p,"gm"),"");
        for(i=0;i<length;i++) {
            list[i]-=flag_p_length*i;
        }
        for(j=0,temp_sum=0;j<min_length;j++) {
            var item_str = getItem(j);
            console.log('handle_survey_position, position='+i+' content=' + item_str);

            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = insertStr(content, item_str, temp_sum+list[j]);
            temp_sum+=item_str.length;
        }
    }

    return content;
}
//处理广告占位符
function handle_advert_position(content,flag_p,getItem) {
    var list = getContentPosition(content, flag_p),
        length = list.length,
        flag_p_length = flag_p.length;
    if(length>0) {
        var i,j,temp_sum;
        content = content.replace(new RegExp(flag_p,"gm"),"");
        for(i=0;i<length;i++) {
            list[i]-=flag_p_length*i;
        }
        for(j=0,temp_sum=0;j<length;j++) {
            var item_str = getItem();
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = insertStr(content, item_str, temp_sum+list[j]);
            temp_sum+=item_str.length;
        }
    }
    return content;
}
// 显示正文 处理图片显示底图 准备加载
function preprocessImage(content, container,shortDocRelateFontSize) {
    var loadMessage = '';
    if(loadMode!=1) {
        loadMessage = getLoadingImage();
    }

    var imgInfo = datas.getImgJson();
    content = processImage(cropper,IMAGE_PLACEHOLDER_HEIGHT,content, container, imgInfo);

    // 显示中心广告
    var advertData = datas.getArticleAdDataJson();
    if(advertData && Object.prototype.toString.call(advertData) == '[object String]'){
    var adBean = JSON.parse(advertData);
    content = handle_advert_position(content, center_ad_p,
        function() {
            if (adBean.type == 'advert') {
             var str = '<div class = "advertdiv" id="advertdiv""></div>';
                if(adBean.link.url){

                     str = '<div class = "advertdiv" id = "advertdiv" style="position:relative;display:block;padding-left:60px;"'
                            +getCenterAdHeightRule(adBean)
                            +'><img id="advert" style="position:relative;width:100%;" class="advert" '
                            +' advertsrc="' + adBean.thumbnail + '" src="'
                            + adBean.link.url + '"/>';
                 }else{
                    return str;
                 }
                 var addTagHtml ='<img id="ad-close" src="ad_detail_clolse.png" '
                    +'style="position:absolute;width:24px;height:24px;top:5px;right:7px;z-index:100"/>'
                    +'<div id="ad_tag" class="adv-tag">&nbsp;广告&nbsp;</div></div>';
                return str + addTagHtml;
            }
        return null;
        });
    }else{
         content = handle_advert_position(content, center_ad_p,
                function() {
                    return '<div class = "advertdiv" id="advertdiv""></div>';
                });
    }
    // 显示slide封面
    var slideData = datas.getExtSlidesJson();
    if(slideData
        && Object.prototype.toString.call(slideData) == '[object String]'){
        var extensionsData = JSON.parse(slideData);
        content = handle_img_position(content, slide_p, extensionsData.length,
            function(i) {
                if (extensionsData[i].type == 'slide') {
                    if(extensionsData[i].title) {
                        return '<p style="margin-top:26px;margin-bottom:11px; '+ getHeightRule(extensionsData[i])+' " class="slide" '+' slidesrc="'
                            + extensionsData[i].thumbnailpic
                            + '" src="'
                            + extensionsData[i].url + '">'+loadMessage+'</p><div><small class="slide-small" style="line-height:23px;">'+extensionsData[i].title+'</small></div>';
                    } else {
                        return '<p style="margin-top:26px;margin-bottom:26px; '+getHeightRule(extensionsData[i]) +'" class="slide" '+ ' slidesrc="'
                            + extensionsData[i].thumbnailpic
                            + '" src="'
                            + extensionsData[i].url + '">'+loadMessage+'</p>';
                    }
                }
                return null;
            });
    }


    // 显示video封面
    var videoData = datas.getVideoJson();
    if(videoData && Object.prototype.toString.call(videoData) == '[object String]'){
        var videos = JSON.parse(videoData);
        content = handle_img_position(content, video_p, videos.length,
            function(i) {
                var videoItemContent = "";
                var videoTitle = videos[i].title;
                if(!videoTitle || videoTitle == "undefined") {
                    videoTitle = "";
                }
                videoItemContent += '<div id="videoContent" class="video video_bg_color" '+getVideoRule(videos[i])+
                '" videoType=normal imgsrc="'+videos[i].thumbnail+
                '" normalSrc="'+videos[i].video.Normal.src+
                '" normalSize="'+videos[i].video.Normal.fileSize+
                '" HDSrc="'+videos[i].video.HD.src+
                '" HDSize="'+videos[i].video.HD.fileSize+
                '" duration="'+videos[i].duration+
                '" guid="'+videos[i].guid+
                '" staticId="'+videos[i].staticId+
                '" columnId="'+videos[i].columnId+
                '" title="'+videoTitle+
                '" thumbnail="'+videos[i].thumbnail+
                '">'+loadMessage+'</div>';
               return videoItemContent;
            });
    }

    //加载音频
    var audioListStr = datas.getAudioJson();
    if(audioListStr && Object.prototype.toString.call(audioListStr) == '[object String]'){
        var audioList = JSON.parse(audioListStr);
         console.info('audioList'+audioList);
         content = handle_survey_position(content,audio_p,audioList.length,
                    function(i){
                       var audioItemContent ='<div class="audio" id="audio" title="'+audioList[i].title+'" desc="'+audioList[i].audioAppDesc+'" duration="'+audioList[i].duration+'" srcNor="'+audioList[i].audio.Normal.src+'" srcHD="'+audioList[i].audio.HD.src+'" guid="'+audioList[i].guid+ '" columnId="'+audioList[i].columnId+'">'+
                                                            '<img src="detail_audio_play.png" class="audio_img" />'+
		                                                    '<div class="audio_info" id="audio_info">'+
		                                                    	'<div class="audio_title" id="audio_title">'+audioList[i].title+'</div>'+
		                                                    	'<div class="audio_desc" id="audio_desc">'+audioList[i].audioAppDesc+'</div>'+
		                                                    '</div>'+
		                                                    '<div class="audio_time" id="audio_time">'+audioList[i].duration+'</div>'+
		                                                    '<div style="clear:both"></div>'+
                                                         '</div>';
                       return audioItemContent;
                    });
    }

    //加载卡片广告
        var cardAdListStr = datas.getCardAdJson();
        if(cardAdListStr && Object.prototype.toString.call(cardAdListStr) == '[object String]'){
            var cardAdList = JSON.parse(cardAdListStr);
             console.info('cardAdList'+cardAdList);
             content = handle_survey_position(content,card_ad_p,cardAdList.length,
                        function(i){
                           var cardAdItemContent ='<div class="cardad" ></div>';
                           return cardAdItemContent;
                        });
        }

    // 核心提示
    var tip = datas.getIntroduction();
    if(tip && Object.prototype.toString.call(tip) == '[object String]'){
        var fragment = document.createElement('div');
        fragment.innerHTML = content;
        var childs = fragment.childNodes;
        if(childs && childs.length>0) {
            var tipContent = "";
            if(childs[0].className == "video_parent"
                || childs[0].className == "slide"
                ||childs[0].className == "placeholder") {
                tipContent = '<div class="tip-news-wrapper">'+tip+'</div>';
            } else {
                tipContent = '<div class="tip-news-wrapper-se">'+tip+'</div><div class="tip-divider-wrapper"><div class="tip-divider">&nbsp;</div></div>';
            }
            content = tipContent+content;
        }
    } else {
        document.getElementById("time-and-source-panel").style.marginBottom = "10px";
    }

    content =  dealWithSurveyPlaceHolder(content);
    /*加载房产样式，加载房产卡片内容*/
    var cardStyle = datas.getHouseCardStyle();
    if(cardStyle != null && cardStyle != "null" && cardStyle != "" && cardStyle != 'undefined'&&Object.prototype.toString.call(cardStyle) == '[object String]'){
        content = insertStr(content, cardStyle, 0);
    }
    content =  buildHouseCard(content);
    // 显示正文
    container.innerHTML = content;
    var eles = Array.prototype.slice.call(container.getElementsByTagName('p'));
    if(eles.length==0){
        container.innerHTML = '<p>'+container.innerHTML+'</p>';
    }

    // 隐藏loading,可以视情况延时调用
    if(!SCREEN_WIDTH){
        SCREEN_WIDTH = '0';
    }
    ifeng.hideLoadingMask(SCREEN_WIDTH);
     addIWordsClickLister(container);
    // 启动加载图片
    setTimeout(loadImages, 200);

}

//获取元素的纵坐标（相对于窗口）
function getTop(e){
    var offset=e.offsetTop;
    if(e.offsetParent!=null) offset+=getTop(e.offsetParent);
    return offset;
}
//获取元素的横坐标（相对于窗口）
function getLeft(e){
    var offset=e.offsetLeft;
    if(e.offsetParent!=null) offset+=getLeft(e.offsetParent);
    return offset;
}

function matchImageUrl(imgUrl) {
    var regx="/[\/_]w(\d{1,4})_h(\d{1,4})/i";
    var rs=regx.exec(imgUrl);
    var rs1=regx.exec(imgUrl);
}

function formatChild(note){
    var nodes = note.childNodes;
    var canBreak = 0;
    for(var i=nodes.length-1;i>=0;i--){
        if(nodes[i].nodeType==1&&nodes[i].nodeName=="P"&&nodes[i].getAttribute("class")!=="placeholder"){
            var cNodes = nodes[i].childNodes;
            for(var j=0;j<cNodes.length;j++){
                if(cNodes[j].nodeType==1){
                    if(j==cNodes.length-1&&(cNodes[j].nodeName=="STRONG"||cNodes[j].nodeName=="SPAN")){
                        if(cNodes[j].childNodes.length>0&&cNodes[j].childNodes[0].nodeName!=="SMALL"){
                            if(!canBreak){
                                canBreak = 1;
                            }
                            break;
                        }
                    }
                }else if(cNodes[j].nodeType==3){
                    var inner = cNodes[j].parentNode.innerHTML;
                    if(inner){
                        if(!canBreak){
                            canBreak = 1;
                        }
                        break;
                    }


                }
            }
        }
    }
    return note;
}

// 滚动加载图片
function loadImages() {
    if(document.getElementById('advertdiv')){
        ifeng.setCenterAdPosition(offsetTop(document.getElementById('advertdiv')));
    }
    var container = document.getElementById('content'),
        placeholders = Array.prototype.slice.call(container.getElementsByClassName('placeholder')),
        src, docId = datas.getDocumentId(),loadMessage = getLoadingImage();
    var VIEWPORT_HEIGHT = window.innerHeight || document.documentElement.clientHeight; // VIEWPORT_HEIGHT || document.body.clientHeight;
    if (VIEWPORT_HEIGHT < 300) {
        VIEWPORT_HEIGHT = 800; // 若获取高度不正确给默认高度800，可能的副作用是浏览正文时会预载更多的图片。
    }
//    console.log('window.innerHeight  '+window.innerHeight+', document.body.clientHeight  '+document.body.clientHeight+', VIEWPORT_HEIGHT  '+VIEWPORT_HEIGHT);
    var videoComponent = container.getElementsByClassName('video');

    var slideComponent = container.getElementsByClassName('slide');

    var advertComponent = container.getElementsByClassName('advert');

    var videoJumpComponent = container.getElementsByClassName('video-bottom');

    var tipContainer = document.getElementById('news-content');
    var tipPlaceHolders = Array.prototype.slice.call(tipContainer.getElementsByClassName('placeholder'))

    var telephoneComponent = container.getElementsByClassName('telephone');

    var goodComponent = container.getElementsByClassName('goodimg');
    var goodItemWapper = container.getElementsByClassName('wemedia_ad');

    if(placeholders && placeholders.length>=0 && tipPlaceHolders && tipPlaceHolders.length>0) {
         placeholders = placeholders.concat(tipPlaceHolders);
    }

    //加载视频图片
    for(var i = 0; i<videoComponent.length; i++) {
        var videoDom = videoComponent[i];
        var jumpDom = videoJumpComponent[i];
        imgQuene.push({
            ot: videoDom.offsetTop,
            dom: videoDom,
            src: videoDom.getAttribute('imgsrc')
        })
        videoDom.onclick = function() {
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('imgsrc');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if(loadState=='loadFail') {
                //如果没有网络连接，直接提示无网络
                if(ifeng.checkNetWorkState() == 0) {
                    return;
                }
                if(loadMode == 1 && !offlineMode) {
                    this.style.backgroundImage = 'url(video_loading.png),url()';
                } else {
                    handle_video_message(this, 1);
                }
                this.setAttribute('loadState','loading');
                Ground.loadImageDirectly(src, docId,
                    loadImageSuccessInterceptor(this),
                    loadImageFailInterceptor(this, src),'forceLoad');
            }
            ifeng.playVideo(window.devicePixelRatio*this.clientHeight,window.devicePixelRatio*getLeft(this), window.devicePixelRatio*getTop(this),this.getAttribute('normalSrc'),this.getAttribute('HDSrc'),this.getAttribute('videoType'),this.getAttribute('duration'),this.getAttribute('guid'),this.getAttribute('staticId'),this.getAttribute('columnId'),this.getAttribute('title'),this.getAttribute('thumbnail'));
        };

        /***
         * 打开凤凰视频app or 下载凤凰视频app。
         */
        if(jumpDom) {
            jumpDom.onclick = function() {
                var guid = this.getAttribute('guid');
                ifeng.jumpIfengVideoApp(guid);
            };
        }
    }

    if(telephoneComponent && telephoneComponent.length > 0){
        var telphoneLabel;
        for(var i = 0; i < telephoneComponent.length; i ++){
            telphoneLabel = telephoneComponent[i];
            telphoneLabel.onclick =  function(){
                //sendWebLog('text telephone', "you click : "+this.innerText);
                ifeng.makeTelephone(this.innerText);
            };
        }
    }
    //加载中心广告图片
    for(var i = 0; i < advertComponent.length; i++) {
            var advertDom = advertComponent[i];
            imgQuene.push({
                ot:  advertDom.offsetTop,
                dom: advertDom,
                src: advertDom.getAttribute('advertsrc')
            })
            document.getElementById('advertdiv').style.width = ifeng.getScreenWidth()-60 +'px';
            document.getElementById('advertdiv').style.height= Math.round((ifeng.getScreenWidth()-120) / BODY_AD_CENTER_RADIO)+'px';
            advertDom.onclick = function() {
                index = parseInt(this.getAttribute('index'));
                src = this.getAttribute('advertsrc');
                isLoaded = (this.className).indexOf('loaded') > -1;
                loadState = this.getAttribute('loadState');
                if(isLoaded) {
                    ifeng.centerAdClick();
                }  else {
                    if(loadState=='loadFail'){
                        //如果没有网络连接，直接提示无网络
                        if(ifeng.checkNetWorkState() == 0) {
                            return;
                        }
                        if(loadMode == 1 && !offlineMode) {
                            this.style.backgroundImage = 'url(slide_text.png),url(logo_loading.png)';
                            this.style.backgroundSize = '40px 22px,auto';
                        } else {
                            this.innerHTML = loadMessage;
                        }
                        this.setAttribute('loadState','loading');
                        Ground.loadImageDirectly(src, docId,
                            loadImageSuccessInterceptor(this),
                            loadImageFailInterceptor(this, src),'forceLoad');
                    }
                }
            };
        }
    //加载图集图片
    for(var i = 0; i < slideComponent.length; i++) {
        var slideDom = slideComponent[i];
        imgQuene.push({
            ot:  slideDom.offsetTop,
            dom: slideDom,
            src: slideDom.getAttribute('slidesrc')
        })

        slideDom.onclick = function() {
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('slidesrc');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if(isLoaded) {
                ifeng.goToSlide(this.getAttribute('src'));
            }  else {
                if(loadState=='loadFail'){
                    //如果没有网络连接，直接提示无网络
                    if(ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    if(loadMode == 1 && !offlineMode) {
                        this.style.backgroundImage = 'url(slide_text.png),url(logo_loading.png)';
                        this.style.backgroundSize = '40px 22px,auto';
                    } else {
                        this.innerHTML = loadMessage;
                    }
                    this.setAttribute('loadState','loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src),'forceLoad');
                }
            }
        };
    }

    for ( var i = 0; i < placeholders.length; i++) {
        var imgDom = placeholders[i];
        src = imgDom.getAttribute('src');
//   console.log('img '+i+' offsetTop=' + imgDom.offsetTop);
        imgQuene.push({
            ot: imgDom.offsetTop,
            dom: imgDom,
            src: src
        })
        if(imgDom.getAttribute("sale_flag") == "1") {
            imgDom.style.borderLeft = "1px solid #F5F5F5";
            imgDom.style.borderRight = "1px solid #F5F5F5";
        }
        // 点击判断加载状态 执行重新加载 或 显示幻灯
        imgDom.onclick = function(i) {
            var index, src, isLoaded, loadState;
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('src');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if(isLoaded) {
                if(this.getAttribute("sale_flag") != "1") {
                    ifeng.popupLightbox(srcs, index, this.getAttribute('jumpUrl'));
                }
            } else {
                if(loadState=='loadFail'){
                    //如果没有网络连接，直接提示无网络
                    if(ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    if(loadMode == 1 || offlineMode) {
                        this.style.backgroundImage = 'url('+nophoto_arrays[1]+')';
                    } else {
                        this.innerHTML = loadMessage;
                    }
                    this.setAttribute('loadState','loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src),'forceLoad');
                }
            }
        };
    }

    // 开始加载所有正文图片
    for(var j = 0, len = imgQuene.length,load; j < len; j++){
        var d = imgQuene[j];
        if(d.dom.getAttribute('imgsrc')) {
            handle_video_message(d.dom, 1);
            if(offlineMode) {
                load = false;
            } else {
                load = true;
            }
        } else if(d.dom.getAttribute('slidesrc') && offlineMode){
            load = false;
        } else {
            load = true;
        }
        Ground.loadImage(d.src, docId,
            loadImageSuccessInterceptor(d.dom, j),
            loadImageFailInterceptor(d.dom, d.src), 'false', load);

    }
    ifeng.startDownload();
}

/*
 处理视频图片加载状态
 state
 0 未加载
 1 正在加载
 2 加载失败
 3 加载成功显示btn
 4 加载成功不显示btn
 */
function handle_video_message(item, state) {
    try {
        var loadMessage = '';
        switch(state) {
            case 0:
            case 2:
                loadMessage = getLoadingImage();
                if(loadMode != 1 || offlineMode) {
                    item.innerHTML = loadMessage+'<div class="video_bottom_content_hide"><div class="video_right_button"><img src="video_button.png"/></div></div>';
                } else {
                    item.innerHTML = loadMessage;
                }
                break;
            case 1:
                loadMessage = getLoadingImage();
                item.innerHTML = loadMessage+'<div class="video_bottom_content_hide"><div class="video_right_button"><img src="video_button.png"/></div></div>';
                break;
            case 3:
                    item.innerHTML ='<div class="video_bottom_content_show"><div class="video_right_button"><img src="video_button.png"/></div></div>';
                break;
            case 4:
                item.innerHTML = '';
                break;
        }
    }catch(e){console.log("error:"+e);};
}


function setImageHeight(placeholder) {
    var height = placeholder.getAttribute("image_height");
    if(height && Object.prototype.toString.call(height) == '[object String]') {
        placeholder.style.height = placeholder.style.minHeight = placeholder.style.maxHeight= height;
        ifeng.resize(document.body.getBoundingClientRect().height);
    }
}


// 图片加载的成功回调
function loadImageSuccessInterceptor(placeholder, imgPosition) {
    return function(src) {
        if(placeholder.nodeName != 'IMG'){
            if(placeholder.getAttribute('imgsrc')) {
                if(src == "none" && loadMode == 1) {
                    handle_video_message(placeholder,4);
                } else {
                    handle_video_message(placeholder,3);
                }
            } else {
                placeholder.innerHTML = '';
            }
        }
        if(src == "none") {
            //设置了无图模式并且网络为2G/3G
            if(offlineMode) {
                placeholder.style.backgroundSize="177.5px 15.5px";
                placeholder.style.backgroundImage = 'url('+nophoto_arrays[0]+')';
            }
            else if(loadMode == 1) {
                if(placeholder.getAttribute('imgsrc')){
                    placeholder.style.backgroundImage = 'url(video_no_load.png),url()';
                }
                else if(placeholder.getAttribute('slidesrc')){
                    placeholder.style.backgroundImage = 'url(slide_text.png),url(logo_no_load.png)';
                } else if(placeholder.getAttribute('advertsrc')){
                    document.getElementById('advertdiv').style.display = 'none';
                }else if(placeholder.getAttribute('likeSrc') || placeholder.getAttribute('recommendSrc')||placeholder.getAttribute('readImgSrc')) {
                    placeholder.src = 'list_no_img.JPG';
                }
                else {
                    placeholder.style.backgroundSize="177.5px 15.5px";
                    placeholder.style.backgroundImage = 'url('+nophoto_arrays[0]+')';
                }
            }
            placeholder.setAttribute('loadState','loadFail');
            return;
        }

        //加载成功了
        var className = placeholder.className;
//		imgQuene[imgPosition] = false;
        if (className.indexOf('loaded') > -1) {
            return;
        }
        if(placeholder.getAttribute('commentImageSrc') || placeholder.getAttribute('likeSrc') || placeholder.getAttribute('recommendSrc')||placeholder.getAttribute('readImgSrc')) {
            placeholder.src = src;
        }
        else if(placeholder.getAttribute('imgsrc')) {
            setImageHeight(placeholder);
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundImage = 'url('+src+')';
        }
        else if(placeholder.getAttribute('advertsrc')) {
            document.getElementById('advertdiv').style.width = ifeng.getScreenWidth()-60 +'px';
            document.getElementById('advertdiv').style.height = Math.round((ifeng.getScreenWidth()-120) / BODY_AD_CENTER_RADIO)+'px';
            placeholder.src = src;

            var adCloseEl = document.getElementById('ad-close');
            adCloseEl.onclick = function (event){
                        ifeng.setCenterAdHint();
                        document.getElementById('advertdiv').style.display = 'none';
                        event.stopPropagation();
                    };
            if(datas.getDocAdClose() == '1'){
                       adCloseEl.style.display = 'visibility';
                    }else{
                        adCloseEl.style.display = 'none';
                    }
            ifeng.setCenterAdPosition(offsetTop(document.getElementById('advertdiv')));
            ifeng.setCenterAdHeight(Math.round((ifeng.getScreenWidth()-120)/BODY_AD_CENTER_RADIO));
        }
        else if(placeholder.getAttribute('slidesrc')) {
            setImageHeight(placeholder);
            placeholder.style.backgroundImage = 'url(slide_text.png),url('+src+')';
            placeholder.style.backgroundSize = '40px 22px,cover';
        }
        else if (placeholder.getAttribute('placeholder_tag')) {
            placeholder.innerHTML= getLoadedImage();
            setImageHeight(placeholder);
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundColor = 'transparent';
            placeholder.style.backgroundPosition = 'center top';
            showLoadedImage(placeholder,src);
        }
        else {
            setImageHeight(placeholder);
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundImage = 'url(' + src + ')';
            placeholder.style.backgroundPosition = 'center top';
            placeholder.style.backgroundColor = 'transparent';
        }
        placeholder.className = className + ' loaded';

    };
}

function getLoadedImage() {
    var loaded = '<img id="loadedImg" style="width: 100%; height: auto; border-radius:4px;"/>'
    return loaded;
}

function showLoadedImage(placeholder,imgUrl) {
    if(placeholder.getAttribute('placeholder_tag')){
        var loadedImg = placeholder.firstChild;
        loadedImg.setAttribute('src',imgUrl);
    }
}

function loadImageFailInterceptor(placeholder, src) {
    return function() {
        if(offlineMode) {
            if(placeholder.nodeName != 'IMG'){
                if(placeholder.getAttribute('imgsrc')) {
                    handle_video_message(placeholder, 2);
                } else if(placeholder.getAttribute('slidesrc')){
                    placeholder.innerHTML = getLoadingImage();
                } else if(placeholder.getAttribute('advertsrc')){
                   document.getElementById('advertdiv').style.display = 'none';
                }else {
                    placeholder.style.backgroundSize="177.5px 15.5px";
                    placeholder.style.backgroundImage = 'url('+nophoto_arrays[2]+')';
                }
            }
        }
        else if (loadMode == 1) {
            if(placeholder.getAttribute('imgsrc')) {
                placeholder.style.backgroundImage = 'url(video_load_fail.png),url()';
            }
            else if(placeholder.getAttribute('advertsrc')) {
               document.getElementById('advertdiv').style.display = 'none';
            }
            else if(placeholder.getAttribute('slidesrc')) {
                placeholder.style.backgroundImage = 'url(slide_text.png),url(logo_load_fail.png)'
            }
            else if(placeholder.getAttribute('recommendSrc')||placeholder.getAttribute('readImgSrc')) {
                placeholder.src = 'list_no_img.JPG';
            }
            else if(placeholder.getAttribute('likeSrc')) {
                placeholder.src = 'album_no_img.JPG';
            }
            else {
                placeholder.style.backgroundSize="177.5px 15.5px";
                placeholder.style.backgroundImage = 'url('+nophoto_arrays[2]+')';
            }
        } else {
            if(placeholder.nodeName != 'IMG'){
                if(placeholder.getAttribute('imgsrc')) {
                    handle_video_message(placeholder, 2);
                } else {
                    placeholder.innerHTML = getLoadingImage();
                }
            }
            if(placeholder.getAttribute('recommendSrc')||placeholder.getAttribute('readImgSrc')) {
                placeholder.src = 'list_default.jpg';
            }
            else if(placeholder.getAttribute('likeSrc')) {
                placeholder.src = 'album_default.JPG';
            }
        }
        placeholder.setAttribute('loadState', 'loadFail');
        sendWebLog('loadImageFailInterceptor load img fail', src);
    };
}

// 订阅模块加载失败回调
function loadSubscriptImageFailInterceptor(placeholder, src) {
    return function() {

        if (loadMode == 1) {
            if(placeholder.getAttribute('imgsrc')) {
                placeholder.style.backgroundImage = 'url(video_load_fail.png),url()';
            }
            else if(placeholder.getAttribute('slidesrc')) {
                placeholder.style.backgroundImage = 'url(slide_text.png),url(logo_load_fail.png)'
            }
            else {
                placeholder.style.backgroundImage = 'url(logo_load_fail.png)';
            }
        } else {
            //	placeholder.innerHTML = '<span class="load-message">点击加载图片</span>';
        }
        placeholder.style.backgroundPosition = 'center top';
        placeholder.setAttribute('loadState', 'loadFail');
        sendWebLog('loadSubscriptImageFailInterceptor load img fail', src);
    };
}

// 与native交互实现
(function() {
    var toString = function(v) {
        return Object.prototype.toString.call(v);
    }, isFunction = function(v) {
        return toString(v) === '[object Function]';
    }, athene = {}, CALLBACK_PREFIX = 'callback__', callbacks = {}, callbackCount = 0, CallbackStatus = {
        OK : 1
    };
    athene.exec = function(success, fail, service, action, params) {
        var callbackId = CALLBACK_PREFIX + callbackCount++;
        callbacks[callbackId] = {
            success : success,
            fail : fail
        };
        params = Array.prototype.concat.call([], callbackId, params || []);
        action.apply(service, params);
    };
    athene.complete = function() {
        if (arguments.length < 2) {
            throw new Error('Missing essential arguments');
        }
        var callbackId = arguments[0], status = arguments[1], callback = callbacks[callbackId], params = Array.prototype.slice
            .call(arguments, 2), success, fail;
        delete callbacks[callbackId];
        if (!callback) {
            return;
        }
        success = callback.success;
        fail = callback.fail;
        if (status == CallbackStatus.OK && isFunction(success)) {
            success.apply(null, params);
//            console.log('params= '+ params[0]);
        } else if (isFunction(fail)) {
            fail.apply(null, params);
        }
    }
    window['athene'] = athene;
})();

// ground 接口
(function() {
    var Ground = {
        loadImage : function(src, documentId, success, fail, forceLoad, load) {
            athene.exec(success, fail, ifeng, ifeng.loadImage, [ src,
                documentId, forceLoad, load]);
        },
        loadImageDirectly : function(src, documentId, success, fail, forceLoad) {
            athene.exec(success, fail, ifeng, ifeng.loadImageDirectly, [ src, documentId,
                forceLoad]);
        },
        loadUserHeadImageDirectly : function(src, documentId, success, fail, forceLoad) {
            athene.exec(success, fail, ifeng, ifeng.loadUserHeadImageDirectly, [ src, documentId,
                forceLoad]);
        },
        popupLightbox : function(src, success) {
            athene.exec(success, null, ifeng, ifeng.popupLightbox, [ src ]);
        },
        addSubscribe : function(success, fail) {
            athene.exec(success, fail, ifeng, ifeng.addSubscribe);
        },
        isSubscribe  : function(success, fail) {
            athene.exec(success, fail, ifeng, ifeng.isSubscribe);
        },
        close  : function() {
            athene.exec("", "", ifeng, ifeng.windowClose);
        },
    };

    window['Ground'] = Ground;
})();


// 屏幕宽度检测
(function() {
    var retry = 0;
    var ScreenDetector = {
        MAX_RETRY_TIMES : 100,
        INTERVAL : 15,
        STORAGE_WIDTH_KEY : '__devicewidth__', // localStorage 存储宽度值的 key

        launch : function() {
            var storage = window.localStorage;
            // 已存储过代表已准备好,document.body.clientWidth的判断用来检查页面是否已显示
            var isReady = storage
                && storage.getItem(this.STORAGE_WIDTH_KEY) && document.body.clientWidth;

            if (isReady) {
                this._ready();
            } else {
                this._docWidth = document.body.clientWidth;
                this._retryTimes = 0;
                this._start();
            }
        },
        _start : function() {
            var self = this;
            setTimeout(function() {
                self._detect();
            }, this.INTERVAL);
        },
        _detect : function() {

            var currentDocWidth,self = this;
            currentDocWidth = document.body.clientWidth;
            if (this._retryTimes < this.MAX_RETRY_TIMES) {
                this._retryTimes++;
                if (this._docWidth != currentDocWidth) {
                    self._ready(currentDocWidth);
                } else {
                    setTimeout(function() {
                        self._detect();
                    }, this.INTERVAL);
                }

            } else {
                self._ready(self._docWidth);
            }
        },
        /**
         * 屏幕宽度检测完成 派发deviceready事件
         *
         * @param docWidth
         *            设置 localstorage 中的 width 值
         * @private
         */
        _ready : function(docWidth) {
            var storage = window.localStorage, clientWidth, ev;
            if (docWidth && storage) {
                storage.setItem(this.STORAGE_WIDTH_KEY, docWidth);
            }
            // 设置 e.clientWidth 变量的值 方便业务逻辑中使用
            clientWidth = parseInt(docWidth
                || storage.getItem(this.STORAGE_WIDTH_KEY));
            ev = document.createEvent('Event');
            ev.clientWidth = clientWidth;
            ev.initEvent('deviceready', false, true);
            window.dispatchEvent(ev);
        }
    };
    window.addEventListener('load', function(e) {
        ScreenDetector.launch();
    }, false);
})();

function initAudio(){
    var container = document.getElementById('content');
    var audioComponent = container.getElementsByClassName('audio');
    for(var i=0;i<audioComponent.length;i++){
        var audioDom = audioComponent[i];
        //audioDom.clientHeight，getleft(audioDom)获取的值在低版本（4.4以下）中是错误的
        //为了兼容低版本手机控件高度写死为60，左边距15；
        ifeng.initAudioLayout(window.devicePixelRatio*70,window.devicePixelRatio, window.devicePixelRatio*(getTop(audioDom)+10),audioDom.getAttribute('title'),audioDom.getAttribute('desc'),audioDom.getAttribute('duration'),audioDom.getAttribute('srcNor'),audioDom.getAttribute('srcHD'),audioDom.getAttribute('guid'));
    }
}

/*
*  正文广告的显示控制
*/
function setBodyAd(src) {
     var bodyAdImage = document.getElementById('body_ad_img');
     bodyAdImage.innerHTML = '';
     if (src == 'none') {
          bodyAdImage.style.backgroundImage = 'url(slide_text.png),url(logo_no_load.png)';
     } else {
          bodyAdImage.style.backgroundImage = 'url(' + src + ')';
     }
}
function getLoadingImage(){
    var loading = '<img src="detail_image_loading.png" class="load-message">';
    return loading;
}
